#ifndef _TCFS_FS_I
#define _TCFS_FS_I

#include <linux/tcfs.h>
#include <linux/pipe_fs_i.h>
#include <asm/semaphore.h>

struct tcfs_inode_info {
	/* see nfs_fs_i.h for more info on this five fields */
	struct pipe_inode_info		pipeinfo;
	unsigned long			read_cache_jiffies;
	unsigned long			read_cache_mtime;
	unsigned long			attrtimeo;
	unsigned short			flags;
	/* TCFS related fields */
	struct tcfs_wreq		*writeback;
	struct tcfs_fh			*fhandle;
	struct tcfs_inode_header	tcfsheader;
	unsigned short			cached;
};

#define TCFS_INO_REVALIDATE	0x0001
#define TCFS_IS_SNAPSHOT	0x0010

/*
 * TCFS lock info
 */
struct tcfs_lock_info {
	u32	state;
	u32	flags;
};

#define TCFS_LCK_GRANTED	0x0001

#endif
